ad_page_contract {
    Subscribes or unsubscribes a user to a mailing list
} {
    {list_ids:multiple,notnull ""}
    unsubscribe:optional
}

set user_id [ad_maybe_redirect_for_registration]
set package_id [ad_conn package_id]

if {[info exists unsubscribe]} {
    # unsubscribe user. i assume that this user currently is subscribed
    db_transaction {
	template::util::list_to_lookup $list_ids lists
	foreach list_id [array names lists] {
	    db_dml unsubscribe_user {}
	}
    }
} else {
    #subscribe user. check if user already has a map entry
    db_transaction {
	template::util::list_to_lookup $list_ids lists
	foreach list_id [array names lists] {
	    if {![db_0or1row check_user_entry_exists {}]} {
		# add new user map entry
		db_dml add_user_entry {}
	    } else {
		# update old user map entry
		db_dml subscribe_user {}
	    }
	    db_1row get_welcome_text {}

	    set unsubscribe_link "[ad_url][ad_conn package_url]?[export_url_vars user_id]"

	    # send welcome email
	    mailing_list::util::send_mail -user_id $user_id -from_email $sender_email -subject $welcome_subject -body $welcome_body -mime_type $welcome_mime_type -charset $mime_charset -link $unsubscribe_link
	}
    }
}

ad_returnredirect "."
